<?php
// OS & Browser Detection
// This file will create all the necessary columns in your database, if they do not exist already.

if (!defined('SMF'))
	die('Hacking attempt...');

global $smcFunc;

db_extend('packages');

$smcFunc['db_add_column']("messages",
                array(
                     'name' => 'ua_os', 'type' => 'tinytext', 'null' => false,
                ),
                array(),
                'do_nothing',
                ''
      );

$smcFunc['db_add_column']("messages",
                array(
                     'name' => 'ua_browser', 'type' => 'tinytext', 'null' => false, 
                ),
                array(),
                'do_nothing',
                ''
      );

$smcFunc['db_add_column']("messages",
                array(
                     'name' => 'ua_os_icon', 'type' => 'tinytext', 'null' => false, 
                ),
                array(),
                'do_nothing',
                ''
      );

$smcFunc['db_add_column']("messages",
                array(
                     'name' => 'ua_browser_icon', 'type' => 'tinytext', 'null' => false, 
                ),
                array(),
                'do_nothing',
                ''
      );
	  
// set default permissions

	// Do it for 'ungrouped members' (ID: 0) & guests (ID: -1).
	$smcFunc['db_insert']('ignore',
			'{db_prefix}permissions',
			array(
				'permission' => 'text', 'id_group' => 'int', 'add_deny' => 'int',
			),
			array(
				'view_os_browser', -1, 1,
			),
			array()
		);
		
	$smcFunc['db_insert']('ignore',
			'{db_prefix}permissions',
			array(
				'permission' => 'text', 'id_group' => 'int', 'add_deny' => 'int',
			),
			array(
				'view_os_browser', 0, 1,
			),
			array()
		);

	// Get all the non-postcount based groups.
	$request = $smcFunc['db_query']('', '
		SELECT id_group
		FROM {db_prefix}membergroups
		WHERE min_posts = -1',
		array()
	);
	
	// Give them all their new permission.
    while ($row = $smcFunc['db_fetch_assoc']($request)){
		$smcFunc['db_insert']('ignore',
			'{db_prefix}permissions',
			array(
				'permission' => 'text', 'id_group' => 'int', 'add_deny' => 'int',
			),
			array(
				'view_os_browser', $row['id_group'], 1,
			),
			array()
		);
	}


?>